SystemOrganization addCategory: #'Pier-Shore'!

PRWidget subclass: #PRShoreTestWidget
	instanceVariableNames: 'list list1 list2 list3 list4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Shore'!

!PRShoreTestWidget commentStamp: 'kph 8/17/2007 03:09' prior: 0!
Aim to show a shore component in a pier-widget as simply as possible, also discover what is need to support shore components.

Note: pier-widgets and shore widgets are not the same thing.

- To use shore components PRPierShoreFrame is needed as your application root component.
- Ensure the approproate libraries are registered in seaside/config 
	see PRPierShoreFrame-applicationNamed:
	or register app using PRPierShoreFrame registerAsApplication: 'piershoredemo'.
	
To use Shore components:
	
1. Subclass PRWidget and write your widget using any shore components you want. This example is copied verbatim from ShoreDemo1ListsDemo
3. Dont forget to set isAbstract to return false if you want your widget to be listed.
!

!PRShoreTestWidget class methodsFor: 'as yet unclassified' stamp: 'kph 8/16/2007 15:19'!
isAbstract

^ false! !

!PRShoreTestWidget methodsFor: 'as yet unclassified' stamp: 'kph 8/16/2007 14:55'!
browse: aClass
	| browser |
	browser := WABrowser fullOnClass: aClass.
	browser addDecoration: (WAWindowDecoration new title: aClass name; yourself).
	self call: browser.! !

!PRShoreTestWidget methodsFor: 'as yet unclassified' stamp: 'kph 8/16/2007 14:55'!
children

	^ Array with: list with: list1 with: list2 with: list3 with: list4! !

!PRShoreTestWidget methodsFor: 'as yet unclassified' stamp: 'kph 8/16/2007 14:53'!
initialize

	| data |

	data := Smalltalk allClasses select: [:c | c name beginsWith: #Shore ].

	super initialize.

	list := ShoreList new.
	list showItemBlock: [:item :filterText | filterText match: item name displayString].
	list onClickBlock: [:item | self shoreInform: item ].
	list data: data.


	list1 := ShoreBatchedList  new.
	list1 title: 'Shore Batched List'.
	list1 data: data.

	list2 := ShoreBatchedList  new.
	list2 title: 'Shore Batched List'.
	list2 data: data.
	list2 itemBlock: 
			[:item :html | 
			html anchor callback: [self browse: item];
				with: item displayString].
	list2 noteBlock: [:item :html | html text: item name size displayString].
	list2 showItemBlock: [:item :filterText | filterText match: item name displayString].
	list2 addSorter: 'name ascending' translated block: [:a :b | a name <= b name].
	list2 addSorter: 'name descending' translated block: [:a :b | b name <= a name].

	list3 := ShoreLiveBatchedList new.
	list3 title: 'Shore Live Batched List'.
	list3 data: data.

	list4 := ShoreLiveBatchedList new.
	list4 title: 'Shore Live Batched List'.
	list4 data: data.
	list4 itemBlock: 
			[:item :html | 
			html anchor callback: [self browse: item];
				with: item displayString].
	list4 noteBlock: [:item :html | html text: item name size displayString].
	list4 showItemBlock: [:item :filterText | filterText match: item name displayString].
	list4 addSorter: 'name ascending' translated block: [:a :b | a name <= b name].
	list4 addSorter: 'name descending' translated block: [:a :b | b name <= a name]! !

!PRShoreTestWidget methodsFor: 'as yet unclassified' stamp: 'kph 8/16/2007 14:55'!
pageTitle

	^ 'ShoreBatchedList demo' translated! !

!PRShoreTestWidget methodsFor: 'as yet unclassified' stamp: 'kph 8/16/2007 14:56'!
renderContentOn: html

	html heading: self pageTitle.

	html paragraph: 'Simple list' translated.
	html render: list.

	html paragraph: 'Simple batched list' translated.
	html render: list1.

	html paragraph: 'Batched list with actions, sorting and notes' translated.
	html render: list2.

	html paragraph: 'Simple live batched list' translated.
	html render: list3.

	html paragraph: 'Live batched list with actions, sorting and notes' translated.
	html render: list4.


! !
